IMPLEMENTATION MODULE MC68882;
FROM SYSTEM IMPORT BYTE,REGISTER,ADR,SETREG,CODE,ADDRESS,LONGWORD;
FROM XBIOS IMPORT SuperExec;
FROM TextIO IMPORT WriteInt,WriteLn,Read,WriteString,WriteReal;
FROM RealInOut IMPORT WriteLongReal;
FROM Conversions IMPORT ConvertToString, ConvertFromString;
FROM InOut IMPORT ReadString, WriteStringRight;
 IMPORT InOut;
FROM MathLib0 IMPORT RadToDeg,DegToRad,real,entier,sin,cos,tan,arctan,exp,
   ln,log,power,sqrt,pi,e;
FROM LongMathLib0 IMPORT longreal;
FROM LongInOut IMPORT WriteLongInt;

CONST FNOP=0F280H;REALOP=04400H;LINTOP=04000H;DREALOP=04800H;
      F68882=0F200H; DADR=018H; 
      FABS=18H;  FACOS=1CH; FASIN=0CH;  FATAN= 0AH;  FATANH = 0DH;
      FCOS=01DH; FSIN=00EH; FTAN=00FH;
      FMOVECR = 0F200H;
      FADD=022H; FDIV= 020H; FMUL=023H; FSUB=028H;
      FSINH=02H; FSQRT=04H; FTANH = 09H; FLOGN=14H; FLOG10=15H;
      FLOG2=16H; FCOSH=19H; FNEG=1AH; FMOD=021H; 
      FTENTOX=12H  ;FETOX=10H ;FTWOTOX=11H;
VAR 
   c1:CHAR;
   x,y,z:REAL;
   j,k,m:LONGINT;
   x1:LONGREAL;

PROCEDURE log2():REAL;
BEGIN
   CODE(FMOVECR);CODE(05C0BH);
   CODE (0F200H  );CODE(6400H);
   x:=REAL(REGISTER(0));
   RETURN x
END log2;


(* $S-,$P-   *)

PROCEDURE CheckChip;
BEGIN
   SETREG(0,0);
   CODE(FNOP);
   floatflag:=BYTE(REGISTER(0));
   CODE(04e75H);  
END CheckChip;
(* $S+,$P+  *)

PROCEDURE Fe():REAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      CODE(FMOVECR);CODE(05C0CH);
      CODE (0F200H  );CODE(6400H);
      RETURN(REAL(REGISTER(0)));
   ELSE RETURN e;
   END;
END Fe;

PROCEDURE Fpi():REAL;
BEGIN
   IF INTEGER(floatflag) = 2 THEN
      CODE(FMOVECR);CODE(05C00H);
      CODE (0F200H  );CODE(6400H);
      RETURN(REAL(REGISTER(0)));
   ELSE RETURN pi;
   END;
END Fpi;

PROCEDURE Wait;
BEGIN   Read(c1);END Wait;

PROCEDURE F2toX(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FTWOTOX);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN power(2.0,x);
   END;
END F2toX;

PROCEDURE FetoX(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FETOX);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN exp(x);
   END;
END FetoX;

PROCEDURE F10toX(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FTENTOX);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN power(10.0,x);
   END;
END F10toX;

PROCEDURE Fneg(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FNEG);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN -x;
   END;
END Fneg;

PROCEDURE Fcosh(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FCOSH);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN 0.5*(exp(x)+exp(-x));
   END;
END Fcosh;

PROCEDURE Flog2(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FLOG2);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN ln(x)/ln(2.0);
   END;
END Flog2;

PROCEDURE Flog10(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FLOG10);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN log(x);
   END;
END Flog10;

PROCEDURE Flogn(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FLOGN);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN ln(x);
   END;
END Flogn;

PROCEDURE Ftanh(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FTANH);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN Fsinh(x)/Fcosh(x);
   END;
END Ftanh;

PROCEDURE Fsqrt(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FSQRT);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN sqrt(x);
   END;
END Fsqrt;

PROCEDURE Fsinh(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FSINH);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN 0.5*(exp(x)-exp(-x));
   END;
END Fsinh;

PROCEDURE Fcos(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FCOS);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN cos(x);
   END;
END Fcos;

PROCEDURE Facos(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FACOS);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN Fasin(pi*0.5-arctan(x/sqrt(1.0-x*x)));
   END;
END Facos;

PROCEDURE Fabs(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FABS);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
      IF x>0.0 THEN RETURN x
      ELSE RETURN (-x);
      END;      
   END;
END Fabs;

PROCEDURE Fsin(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FSIN);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN sin(x);
   END;
END Fsin;

PROCEDURE Fasin(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FASIN);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN arctan(x/sqrt(1.0-x*x));
   END;
END Fasin;

PROCEDURE Ftan(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FTAN);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN tan(x);
   END;
END Ftan;

PROCEDURE Fatan(x:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE(F68882);CODE(REALOP+FATAN);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN arctan(x);
   END;
END Fatan;

PROCEDURE Fadd(x,y:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE (0F200H  );CODE(REALOP);
      SETREG(0,y);
      CODE(F68882);CODE(REALOP+FADD);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN (x+y);
   END;
END Fadd;

PROCEDURE Fmod(x,y:REAL):REAL;
BEGIN
   IF y=0.0 THEN RETURN 1000000.0;END;
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE (0F200H  );CODE(REALOP);
      SETREG(0,y);
      CODE(F68882);CODE(REALOP+FMOD);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN (x / y);
   END;
END Fmod;

PROCEDURE Fdiv(x,y:REAL):REAL;
BEGIN
   IF y=0.0 THEN RETURN 1000000.0;END;
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE (0F200H  );CODE(REALOP);
      SETREG(0,y);
      CODE(F68882);CODE(REALOP+FDIV);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN (x/y);
   END;
END Fdiv;

PROCEDURE Fmul(x,y:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE (0F200H  );CODE(REALOP);
      SETREG(0,y);
      CODE(F68882);CODE(REALOP+FMUL);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN (x*y);
   END;
END Fmul;

PROCEDURE Fsub(x,y:REAL):REAL;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE (0F200H  );CODE(REALOP);
      SETREG(0,y);
      CODE(F68882);CODE(REALOP+FSUB);
      CODE (0F200H  );CODE(6400H);
      RETURN (REAL(REGISTER(0)));
   ELSE 
        RETURN (x-y);
   END;
END Fsub;

PROCEDURE Iadd(x,y:LONGINT):LONGINT;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE (0F200H  );CODE(REALOP);
      SETREG(0,y);
      CODE(F68882);CODE(LINTOP+FADD);
      CODE (0F200H  );CODE(6400H);
      RETURN (LONGINT(REGISTER(0)));
   ELSE 
        RETURN x+y;
   END;
END Iadd;

PROCEDURE Isub(x,y:LONGINT):LONGINT;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE (0F200H  );CODE(REALOP);
      SETREG(0,y);
      CODE(F68882);CODE(LINTOP+FSUB);
      CODE (0F200H  );CODE(6400H);
      RETURN (LONGINT(REGISTER(0)));
   ELSE 
        RETURN x-y;
   END;
END Isub;

PROCEDURE Imul(x,y:LONGINT):LONGINT;
BEGIN
   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE (0F200H  );CODE(REALOP);
      SETREG(0,y);
      CODE(F68882);CODE(LINTOP+FMUL);
      CODE (0F200H  );CODE(6400H);
      RETURN (LONGINT(REGISTER(0)));
   ELSE 
        RETURN x*y;
   END;
END Imul;

PROCEDURE Idiv(x,y:LONGINT):LONGINT;
BEGIN
   IF y=0 THEN RETURN 1000000;END;

   IF INTEGER(floatflag)=2 THEN
      SETREG(0,x);
      CODE (0F200H  );CODE(REALOP);
      SETREG(0,y);
      CODE(F68882);CODE(LINTOP+FDIV);
      CODE (0F200H  );CODE(6400H);
      RETURN (LONGINT(REGISTER(0)));
   ELSE 
        RETURN x DIV y;
   END;
END Idiv;

BEGIN
   floatflag:=BYTE(1);
   SuperExec(CheckChip);
(*   WriteString("Here it is");
   WriteInt(INTEGER(floatflag),8);Wait; *)
END MC68882.


